# perl_codegen.py : perl generator functions for wxRadioBox objects
# $Id: perl_codegen.py,v 1.2 2003/06/25 23:51:26 crazyinsomniac Exp $
#
# Copyright (c) 2002-2003 D.H. aka crazyinsomniac on sourceforge.net
# License: MIT (see license.txt)
# THIS PROGRAM COMES WITH NO WARRANTY

import common
from ChoicesCodeHandler import *


class PerlCodeGenerator:
    def get_code(self, obj):
        init = []
        plgen = common.code_writers['perl']
        prop = obj.properties
        id_name, id = plgen.generate_code_id(obj) 
        label = plgen.quote_str(prop.get('label', ''))
        choices = prop.get('choices', [])
        major_dim = prop.get('dimension', '0')

        if not obj.parent.is_toplevel:
            parent = '$self->{%s}' % obj.parent.name
        else:
            parent = '$self'

        style = prop.get("style")
        if not style : style = ''

        if id_name: init.append(id_name)

        choices = ', '.join([plgen.quote_str(c) for c in choices])
        init.append('$self->{%s} = %s->new(%s, %s, %s, wxDefaultPosition, \
wxDefaultSize, [%s], %s, %s);\n' % (obj.name, obj.klass.replace('wx','Wx::',1),
            parent, id, label,  choices, major_dim, style))

        props_buf = plgen.generate_common_properties(obj)
        selection = prop.get('selection')
        if selection is not None:
            props_buf.append('$self->{%s}->SetSelection(%s);\n' %
                             (obj.name, selection))
        return init, props_buf, []

# end of class PerlCodeGenerator


def initialize():
    common.class_names['EditRadioBox'] = 'wxRadioBox'

    plgen = common.code_writers.get('perl')
    if plgen:
        plgen.add_widget_handler('wxRadioBox', PerlCodeGenerator())
        plgen.add_property_handler('choices', ChoicesCodeHandler)
